function b=fastftptrain(xt,epst,M)
%fastftptrain(xt,epst,M) calculate fourier coefficients of a function that
%its value between xt(i-1) and xt(i) is epst(i). length(epst)= length(xt)+1
b=zeros(1,2*M+1);
lxt=length(xt);

for n=-M:M
    if n~=0
        x1=0;
        x2=xt(1);        
        b(n+M+1)=1i*epst(1)*(exp(-1i*2*pi*n*x2)-exp(-1i*2*pi*n*x1))/(2*pi*n);
        for j=2:lxt
            x1=xt(j-1);
            x2=xt(j);
            b(n+M+1)=b(n+M+1)+i*epst(j)*(exp(-i*2*pi*n*x2)-exp(-i*2*pi*n*x1))/(2*pi*n);
        end
        j = lxt;
        x1=xt(j);
        x2=1;
        b(n+M+1)=b(n+M+1)+i*epst(j+1)*(exp(-i*2*pi*n*x2)-exp(-i*2*pi*n*x1))/(2*pi*n);        
    end
end
x1=0;
x2=xt(1);
b(M+1)=(x2-x1)*epst(1);
for j=2:lxt
    x1=xt(j-1);
    x2=xt(j);
    b(M+1)=b(M+1)+(x2-x1)*epst(j);
end
j = lxt;
x1=xt(j);
x2=1; 
b(M+1)=b(M+1)+(x2-x1)*epst(j+1);